Imports I7565CPM_Net

Public Class Form1

    Dim COMPORT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte
    Dim ISADD(128) As Byte

    Dim BlockMode As Byte = 1

    Dim DelayTime As UInt16
    Dim ret As UInt16
    Dim errstr As String

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim i As Int16

        COMPORT = 0
        BAUD = 0
        NODE = 1

        Combo_Com.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Com.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0

        Btn_Initial.Enabled = True
        Btn_Shutdown.Enabled = False
        Btn_AddNode.Enabled = False
        Btn_LoadEDS.Enabled = False
        Btn_Remove.Enabled = False

        List_EntryData.Items.Clear()

        For i = 0 To 128
            ISADD(i) = 0
        Next
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Call I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
    End Sub

    Private Sub Combo_Com_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Com.SelectedIndexChanged
        COMPORT = Combo_Com.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged

        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged

        NODE = Combo_Node.SelectedIndex + 1

        If ISADD(NODE) = 1 Then
            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_LoadEDS.Enabled = False
            Btn_LoadEDS.Visible = False
            Btn_Remove.Enabled = True

            Call UpdateList()
        ElseIf ISADD(NODE) = 0 Then
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Btn_LoadEDS.Enabled = True
            Btn_LoadEDS.Visible = True
            Btn_Remove.Enabled = False

            List_EntryData.Items.Clear()
        End If
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click

        ret = I7565CPM.I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Com.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Btn_LoadEDS.Enabled = True
            Btn_LoadEDS.Visible = True

            ' Set to listen mode
            Call I7565CPM.I7565CPM_SetMasterMode(COMPORT, 1, BlockMode)

            Timer1.Enabled = True

        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click
        Dim i As Int16

        ret = I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Com.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Combo_Baud.SelectedIndex = 0

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = True
            Btn_LoadEDS.Enabled = False
            Btn_LoadEDS.Visible = True
            Btn_Remove.Enabled = False

            For i = 0 To 128
                ISADD(i) = 0
            Next

            List_EntryData.Items.Clear()

            Timer1.Enabled = False

        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click

        ret = I7565CPM.I7565CPM_AddNode(COMPORT, NODE, 2, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Dim EntryUse As Byte
            Dim PDOId As UInt16, i As UInt16, j As UInt16
            Dim EntryData(8) As UInt32

            ISADD(NODE) = 1

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_LoadEDS.Enabled = False
            Btn_LoadEDS.Visible = False
            Btn_Remove.Enabled = True

            ' Set EMCY ID to master list
            Call I7565CPM.I7565CPM_SetEMCY_List(COMPORT, NODE, (&H80 + NODE), BlockMode)

            ' Install RxPDO to master PDO list
            For i = 0 To 3
                PDOId = &H200 + NODE + (&H100 * i)

                If i = 0 Then
                    EntryUse = 8
                Else
                    EntryUse = 4
                End If

                For j = 0 To (EntryUse - 1)
                    If i = 0 Then
                        EntryData(j) = &H62000108 + (&H100 * j)
                    Else
                        EntryData(j) = &H64110110 + (&H100 * (j + ((i - 1) * EntryUse)))
                    End If
                Next j

                Call I7565CPM.I7565CPM_InstallPDO_List(COMPORT, NODE, PDOId, 0, i + 1, 255, 0, EntryUse, EntryData, BlockMode)
            Next i

            ' Install TxPDO to master PDO list
            For i = 0 To 3
                PDOId = &H180 + NODE + (&H100 * i)

                If i = 0 Then
                    EntryUse = 8
                Else
                    EntryUse = 4
                End If

                For j = 0 To (EntryUse - 1)
                    If i = 0 Then
                        EntryData(j) = &H60000108 + (&H100 * j)
                    Else
                        EntryData(j) = &H64010110 + (&H100 * (j + ((i - 1) * EntryUse)))
                    End If
                Next j

                Call I7565CPM.I7565CPM_InstallPDO_List(COMPORT, NODE, PDOId, 1, i + 1, 255, 0, EntryUse, EntryData, BlockMode)
            Next i
        End If
    End Sub

    Private Sub Btn_LoadEDS_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_LoadEDS.Click
        Dim EDSFile As OpenFileDialog = New OpenFileDialog()

        EDSFile.Filter = "EDS files (*.eds)|*.eds"
        EDSFile.FilterIndex = 1

        If (EDSFile.ShowDialog() = DialogResult.OK) Then
            ret = I7565CPM.I7565CPM_EDS_Load(COMPORT, NODE, EDSFile.FileName, DelayTime, 200, BlockMode)
            If (ret <> 0) Then
                MessageBox.Show("EDS File Load Error = " + ret.ToString("D"))
                Return
            End If
        Else
            ISADD(NODE) = 1

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_LoadEDS.Enabled = False
            Btn_LoadEDS.Visible = False
            Btn_Remove.Enabled = True
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click

        ret = I7565CPM.I7565CPM_RemoveNode(COMPORT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            ISADD(NODE) = 0

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Btn_LoadEDS.Enabled = True
            Btn_LoadEDS.Visible = True
            Btn_Remove.Enabled = False

            List_EntryData.Items.Clear()
        End If
    End Sub

    Private Sub UpdateList()
        Dim PDO_Cnt As Byte, NMT_State As Byte
        Dim EMCYId As UInt16, i As UInt16, j As UInt16
        Dim Id_List(10) As UInt16
        Dim Temp_Str As String

        List_EntryData.Items.Clear()

        ret = I7565CPM.I7565CPM_NMTGetState(COMPORT, NODE, NMT_State, BlockMode)
        If ret = 0 Then
            Temp_Str = "NMT State:"

            Select Case (NMT_State)
                Case &H4 ' Stop mode
                    Temp_Str = Temp_Str + " Stop mode"
                Case &H5 ' Operation mode
                    Temp_Str = Temp_Str + " Operation mode"
                Case &H7F ' Pre-operation mode
                    Temp_Str = Temp_Str + " Pre-operation mode"
            End Select
            List_EntryData.Items.Add(Temp_Str)
        End If

        ret = I7565CPM.I7565CPM_GetEMCYID(COMPORT, NODE, EMCYId, BlockMode)
        If ret = 0 Then
            If EMCYId <> 0 Then
                Dim IsNew As Byte
                Dim Data(8) As Byte

                ret = I7565CPM.I7565CPM_ReadLastEMCY(COMPORT, NODE, IsNew, Data, BlockMode)
                If (ret = 0) Or (ret = I7565CPM._15_CPM_DataEmpty) Then
                    Temp_Str = "EMCY " + EMCYId.ToString("X") + " : "

                    For i = 0 To 7
                        Temp_Str = Temp_Str + Data(i).ToString("X2") + " "
                    Next

                    List_EntryData.Items.Add(Temp_Str)
                End If
            End If
        End If

        ret = I7565CPM.I7565CPM_GetRxPDOID(COMPORT, NODE, PDO_Cnt, Id_List, BlockMode)
        If ret = 0 Then
            Dim IsNew As Byte, DLen As Byte
            Dim Data(8) As Byte

            For i = 0 To PDO_Cnt - 1
                For j = 0 To 7
                    Data(j) = 0
                Next

                ret = I7565CPM.I7565CPM_GetPDOLastData(COMPORT, Id_List(i), IsNew, DLen, Data, BlockMode)
                If (ret = 0) Or (ret = I7565CPM._15_CPM_DataEmpty) Then
                    Temp_Str = "RxPDO " + Id_List(i).ToString("X") + " : "

                    For j = 0 To 7
                        Temp_Str = Temp_Str + Data(j).ToString("X2") + " "
                    Next

                    List_EntryData.Items.Add(Temp_Str)
                End If
            Next
        End If

        ret = I7565CPM.I7565CPM_GetTxPDOID(COMPORT, NODE, PDO_Cnt, Id_List, BlockMode)
        If ret = 0 Then
            Dim IsNew As Byte, DLen As Byte
            Dim Data(8) As Byte

            For i = 0 To PDO_Cnt - 1
                For j = 0 To 7
                    Data(j) = 0
                Next

                ret = I7565CPM.I7565CPM_GetPDOLastData(COMPORT, Id_List(i), IsNew, DLen, Data, BlockMode)
                If (ret = 0) Or (ret = I7565CPM._15_CPM_DataEmpty) Then
                    Temp_Str = "TxPDO " + Id_List(i).ToString("X") + " : "

                    For j = 0 To 7
                        Temp_Str = Temp_Str + Data(j).ToString("X2") + " "
                    Next

                    List_EntryData.Items.Add(Temp_Str)
                End If
            Next
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Call UpdateList()
    End Sub
End Class
