Imports I7565CPM_Net

Public Class Form1

    Dim COMPORT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte
    Dim STA As Byte

    Dim BlockMode As Byte = 1

    Dim STA_Str As String = ""
    Dim EMCY As String = ""
    Dim NMTErr As String = ""

    Dim DelayTime As UShort
    Dim ret As UShort
    Dim errstr As String

    Dim MyNMTErrISR As I7565CPM.NMTErrISR
    Dim MyEMCYISR As I7565CPM.EMCYISR

    Private Sub UserNMTErrISR()

        Dim board As Byte, node As Byte, mode As Byte
        Dim tempstr As String = ""

        If (I7565CPM.I7565CPM_GetNMTError(board, node, mode) = 0) Then

            If (mode = I7565CPM.CPM_Node_Guarding_Event) Then

                tempstr = "NMTErr: Board " + board.ToString("D") + ", Node " + node.ToString("D") + " Guarding Fail"

            ElseIf (mode = I7565CPM.CPM_Heartbeat_Event) Then

                tempstr = "NMTErr: Board " + board.ToString("D") + ", Node " + node.ToString("D") + " Heartbeat Error"
            End If
        End If

        NMTErr = tempstr

    End Sub

    Private Sub UserEMCYISR()

        Dim board As Byte, node As Byte
        Dim data(8) As Byte
        Dim tempstr As String = ""

        If (I7565CPM.I7565CPM_GetEMCYData(board, node, data) = 0) Then

            Dim i As UShort

            tempstr = "EMCY: Board " + board.ToString("D") + ", Node " + node.ToString("D") + " :"

            For i = 0 To 7
                tempstr = tempstr + data(i).ToString("X2") + " "
            Next

        End If

        EMCY = tempstr

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        COMPORT = 0
        BAUD = 0
        NODE = 1

        STA = &H1
        STA_Str = "Operation mode"

        Combo_Com.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Com.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0
        Combo_State.SelectedIndex = 0

        Btn_Initial.Enabled = True
        Btn_Shutdown.Enabled = False
        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        MyNMTErrISR = New I7565CPM.NMTErrISR(AddressOf UserNMTErrISR)
        MyEMCYISR = New I7565CPM.EMCYISR(AddressOf UserEMCYISR)

        pal_NMT.Enabled = False
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
    End Sub

    Private Sub Combo_Com_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Com.SelectedIndexChanged
        COMPORT = (Combo_Com.SelectedIndex)
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged

        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        NODE = Combo_Node.SelectedIndex + 1
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click

        ret = I7565CPM.I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode)
        If (ret <> 0) Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)

        Else

            I7565CPM.I7565CPM_InstallNMTErrISR(COMPORT, MyNMTErrISR)
            I7565CPM.I7565CPM_InstallEMCYISR(COMPORT, MyEMCYISR)

            Combo_Com.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True

            timer1.Enabled = True
        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click

        ret = I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            I7565CPM.I7565CPM_RemoveNMTErrISR(COMPORT)
            I7565CPM.I7565CPM_RemoveEMCYISR(COMPORT)

            Combo_Com.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = True
            Btn_Remove.Enabled = False

            pal_NMT.Enabled = False

            timer1.Enabled = False

            List_EMCY.Items.Clear()

        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click

        ret = I7565CPM.I7565CPM_AddNode(COMPORT, NODE, 2, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_Remove.Enabled = True
            Combo_Node.Enabled = False

            pal_NMT.Enabled = True
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click

        ret = I7565CPM.I7565CPM_RemoveNode(COMPORT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Btn_Remove.Enabled = False
            Combo_Node.Enabled = True

            List_EMCY.Items.Clear()

            pal_NMT.Enabled = False
        End If
    End Sub

    Private Sub Combo_State_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_State.SelectedIndexChanged

        Select Case (Combo_State.SelectedIndex)
            Case 0
                STA = &H1   '/Operation mode
                STA_Str = "Operation mode"
            Case 1
                STA = &H2   'Stop mode
                STA_Str = "Stop mode"
            Case 2
                STA = &H80   'Pre-Operation mode
                STA_Str = "Pre-Operation mode"
            Case 3
                STA = &H81   'Reset Node
                STA_Str = "Reset Node"
            Case 4
                STA = &H82   'Reset Communication
                STA_Str = "Reset Communication"
        End Select

    End Sub

    Private Sub Btn_SetState_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetState.Click

        ret = I7565CPM.I7565CPM_NMTChangeState(COMPORT, NODE, STA, BlockMode)
        If (ret <> 0) Then
            errstr = "Change Slave State Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)

        Else
            errstr = "Change Slave State to" + STA_Str + " OK"
            List_EMCY.Items.Add(errstr)
        End If
    End Sub

    Private Sub Btn_Clear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Clear.Click
        List_EMCY.Items.Clear()
    End Sub

    Private Sub Check_Is_Dec(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_GuardTime.KeyPress

        If (("1234567890".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If
    End Sub

    Private Sub Btn_SetGuard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetGuard.Click
        Dim GuardTime As UInt16
        Dim LifeTime As Byte

        GuardTime = Val(Text_GuardTime.Text)
        LifeTime = Val(Text_LifeTime.Text)

        ret = I7565CPM.I7565CPM_NMTGuarding(COMPORT, NODE, GuardTime, LifeTime, BlockMode)
        If ret <> 0 Then
            errstr = "Set Guarding Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            errstr = "Set Guarding OK"
            List_EMCY.Items.Add(errstr)
        End If
    End Sub

    Private Sub Btn_SetHeartbeat_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetHeartbeat.Click
        Dim Heartbeat As UInt16, Consumer As UInt16

        Heartbeat = Val(Text_Heartbeat.Text)
        Consumer = Val(Text_Consumer.Text)

        ret = I7565CPM.I7565CPM_NMTHeartbeat(COMPORT, NODE, Heartbeat, Consumer, BlockMode)
        If ret <> 0 Then
            errstr = "Set Heartbeat Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            errstr = "Set Heartbeat OK"
            List_EMCY.Items.Add(errstr)
        End If
    End Sub

    Private Sub timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles timer1.Tick

        If (EMCY <> "") Then
            List_EMCY.Items.Add(EMCY)
            EMCY = ""
        End If

        If (NMTErr <> "") Then
            List_EMCY.Items.Add(NMTErr)
            NMTErr = ""
        End If
    End Sub
End Class
