Imports I7565CPM_Net

Public Class Form1

    Dim COMPORT As Byte
    Dim BAUD As Byte
    Dim NODE As Byte

    Dim BlockMode As Byte = 1

    Dim PDOTYPE As Byte
    Dim PDOCOBID As UShort

    Dim DelayTime As UInt16
    Dim ret As UInt16
    Dim errstr As String

    Private Sub GetPDOID()
        Dim PDO_Cnt As Byte
        Dim Id_List(10) As UShort, i As UShort

        Combo_PDOID.Items.Clear()

        If PDOTYPE <> 0 Then
            ret = I7565CPM.I7565CPM_GetTxPDOID(COMPORT, NODE, PDO_Cnt, Id_List, BlockMode)
        Else
            ret = I7565CPM.I7565CPM_GetRxPDOID(COMPORT, NODE, PDO_Cnt, Id_List, BlockMode)
        End If

        If ret = 0 Then
            For i = 0 To (PDO_Cnt - 1)
                Combo_PDOID.Items.Add(Id_List(i).ToString("X3"))
            Next
        End If

        If PDO_Cnt <> 0 Then Combo_PDOID.SelectedIndex = 0

        Call GetPDOMapData()
    End Sub

    Private Sub GetPDOMapData()
        Dim PDO_Index As UShort, PDONo As UShort, i As UShort
        Dim PDO_Type As Byte, Transmit_Type As Byte, Entry_Cnt As Byte
        Dim Event_Timer As UShort
        Dim Map_Data(10) As UInt32

        List_MapData.Items.Clear()

        PDOCOBID = 0

        If (Combo_PDOID.Items.Count() = 0) Then
            Exit Sub
        End If

        PDO_Index = Combo_PDOID.SelectedIndex

        ' Convert text to PDO ID number
        PDOCOBID = Val("&H" + Combo_PDOID.Text())

        ' Get Mapping Data
        ret = I7565CPM.I7565CPM_GetPDOMapInfo(COMPORT, PDOCOBID, PDONo, PDO_Type, Transmit_Type, Event_Timer, Entry_Cnt, Map_Data, BlockMode)
        If ret = 0 Then
            List_MapData.Items.Add("Transmission Type: " + Transmit_Type.ToString("D"))

            List_MapData.Items.Add("Event Timer: " + Event_Timer.ToString("D"))

            List_MapData.Items.Add("Mapping Data: ")

            If Entry_Cnt = 0 Then
                List_MapData.Items.Add("None")
            Else
                For i = 0 To (Entry_Cnt - 1)
                    List_MapData.Items.Add("Entry " + (i + 1).ToString("D") + ": " + Map_Data(i).ToString("X8"))
                Next
            End If
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        COMPORT = 0
        BAUD = 0
        NODE = 1

        PDOCOBID = 0
        PDOTYPE = 0

        Combo_Com.Enabled = True
        Combo_Baud.Enabled = True
        Combo_Node.Enabled = False

        Combo_Com.SelectedIndex = 0
        Combo_Baud.SelectedIndex = 0
        Combo_Node.SelectedIndex = 0

        Btn_AddNode.Enabled = False
        Btn_AddNode.Visible = True
        Btn_Remove.Enabled = False

        Pal_PDOInstall.Enabled = False
        Pal_PDOParameter.Enabled = False
    End Sub

    Private Sub Form1_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed
        Call I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
    End Sub

    Private Sub Combo_Com_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Com.SelectedIndexChanged
        COMPORT = Combo_Com.SelectedIndex
    End Sub

    Private Sub Combo_Baud_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Baud.SelectedIndexChanged
        BAUD = Combo_Baud.SelectedIndex

        Select Case (BAUD)
            Case 0
                DelayTime = 15
            Case 1
                DelayTime = 7
            Case 2
                DelayTime = 3
            Case 3
            Case 4
                DelayTime = 1
            Case 5
            Case 6
            Case 7
                DelayTime = 0
        End Select
    End Sub

    Private Sub Combo_Node_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_Node.SelectedIndexChanged
        NODE = Combo_Node.SelectedIndex + 1
    End Sub

    Private Sub Combo_PDOType_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_PDOType.SelectedIndexChanged

        PDOTYPE = Combo_PDOType.SelectedIndex
        Call GetPDOID()
    End Sub

    Private Sub Combo_PDOID_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Combo_PDOID.SelectedIndexChanged
        Call GetPDOMapData()
    End Sub

    Private Sub Btn_Initial_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Initial.Click
        ret = I7565CPM.I7565CPM_InitMaster(COMPORT, 0, BAUD, BlockMode)
        If ret <> 0 Then
            errstr = "Initial Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Com.Enabled = False
            Combo_Baud.Enabled = False
            Combo_Node.Enabled = True

            Btn_Initial.Enabled = False
            Btn_Initial.Visible = False
            Btn_Shutdown.Enabled = True

            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
        End If
    End Sub

    Private Sub Btn_Shutdown_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Shutdown.Click
        ret = I7565CPM.I7565CPM_ShutdownMaster(COMPORT)
        If ret <> 0 Then
            errstr = "Shutdown Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Combo_Com.Enabled = True
            Combo_Baud.Enabled = True
            Combo_Node.Enabled = False

            Btn_Initial.Enabled = True
            Btn_Initial.Visible = True
            Btn_Shutdown.Enabled = False

            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = True
            Btn_Remove.Enabled = False

            Pal_PDOInstall.Enabled = False
            Pal_PDOParameter.Enabled = False
        End If
    End Sub

    Private Sub Btn_AddNode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_AddNode.Click
        ret = I7565CPM.I7565CPM_AddNode(COMPORT, NODE, 1, DelayTime, 200, BlockMode)
        If ret <> 0 Then
            errstr = "AddNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_AddNode.Enabled = False
            Btn_AddNode.Visible = False
            Btn_Remove.Enabled = True
            Combo_Node.Enabled = False

            Combo_PDOType.SelectedIndex = 0
            Combo_Install_Type.SelectedIndex = 0

            Pal_PDOInstall.Enabled = True
            Pal_PDOParameter.Enabled = True

            Call GetPDOID()
        End If
    End Sub

    Private Sub Btn_Remove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_Remove.Click
        ret = I7565CPM.I7565CPM_RemoveNode(COMPORT, NODE, BlockMode)
        If ret <> 0 Then
            errstr = "RemoveNode Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Btn_Remove.Enabled = False
            Btn_AddNode.Enabled = True
            Btn_AddNode.Visible = True
            Combo_Node.Enabled = True

            Pal_PDOInstall.Enabled = False
            Pal_PDOParameter.Enabled = False
        End If
    End Sub

    Private Sub Check_Is_Dec(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_TransmitType.KeyPress, Text_PDOEntryNo.KeyPress, Text_Install_No.KeyPress, Text_EventTimer.KeyPress, Text_Entry.KeyPress

        If ((("1234567890".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) = False) Then e.Handled = True

    End Sub

    Private Sub Check_Is_Hex(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles Text_NewID.KeyPress, Text_Install_ID.KeyPress, Text_EntryData.KeyPress

        If ((("1234567890ABCDEFabcdef".IndexOf(e.KeyChar) <> -1) Or (Convert.ToInt16(e.KeyChar) = 8)) = False) Then e.Handled = True

    End Sub

    Private Sub Btn_InstallPDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_InstallPDO.Click
        Dim RxTx As Byte
        Dim CobId As UShort, PDO_No As UShort

        CobId = Val("&H" + Text_Install_ID.Text)
        PDO_No = Val(Text_Install_No.Text)
        RxTx = Combo_Install_Type.SelectedIndex

        ret = I7565CPM.I7565CPM_InstallPDO(COMPORT, NODE, CobId, RxTx, PDO_No, BlockMode)
        If ret <> 0 Then
            errstr = "InstallPDO Error, = " + Str(ret)
            MessageBox.Show(errstr)
        Else
            If PDOTYPE = RxTx Then
                Call GetPDOID()
            End If
        End If
    End Sub

    Private Sub Btn_RemovePDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_RemovePDO.Click
        Dim Entry As Byte

        Entry = Val(Text_Entry.Text)

        ret = I7565CPM.I7565CPM_RemovePDO(COMPORT, NODE, PDOCOBID, Entry, BlockMode)
        If ret <> 0 Then
            errstr = "RemovePDO Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            If Entry <> 0 Then  ' Entry != 0, Remove single entry
                Call GetPDOMapData()
            Else                ' Entry = 0, Remove whole PDO
                Call GetPDOID()
            End If
        End If
    End Sub

    Private Sub Btn_DynamicPDO_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_DynamicPDO.Click
        Dim Entry As Byte
        Dim EntryData As UInt32

        Entry = Val(Text_Entry.Text)

        EntryData = CUInt(Val("&H" + Text_EntryData.Text))

        ret = I7565CPM.I7565CPM_DynamicPDO(COMPORT, NODE, PDOCOBID, PDOTYPE, Entry, EntryData, BlockMode)
        If ret <> 0 Then
            errstr = "DynamicPDO Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call GetPDOMapData()
        End If
    End Sub

    Private Sub Btn_ChangePDOID_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_ChangePDOID.Click
        Dim New_PDO As UShort

        New_PDO = CUShort(Val("&H" + Text_NewID.Text))

        ret = I7565CPM.I7565CPM_ChangePDOID(COMPORT, PDOCOBID, New_PDO, BlockMode)
        If ret <> 0 Then
            errstr = "ChangePDOID Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call GetPDOID()
        End If
    End Sub

    Private Sub Btn_SetTxType_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetTxType.Click
        Dim Tx_Type As Byte

        Tx_Type = Val(Text_TransmitType.Text)

        ret = I7565CPM.I7565CPM_PDOTxType(COMPORT, PDOCOBID, Tx_Type, BlockMode)
        If ret <> 0 Then
            errstr = "PDOTxType Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call GetPDOMapData()
        End If
    End Sub

    Private Sub Btn_SetEntryNo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetEntryNo.Click
        Dim Entry As Byte

        Entry = Val(Text_PDOEntryNo.Text)

        ret = I7565CPM.I7565CPM_PDOUseEntry(COMPORT, PDOCOBID, Entry, BlockMode)
        If ret <> 0 Then
            errstr = "PDOUseEntr Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call GetPDOMapData()
        End If
    End Sub

    Private Sub Btn_SetEventTime_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btn_SetEventTime.Click
        Dim Timer As UShort

        Timer = Val(Text_EventTimer.Text)

        ret = I7565CPM.I7565CPM_PDOEventTimer(COMPORT, PDOCOBID, Timer, BlockMode)
        If ret <> 0 Then
            errstr = "PDOEventTimer Error, = " + ret.ToString("D")
            MessageBox.Show(errstr)
        Else
            Call GetPDOMapData()
        End If
    End Sub
End Class

